<html>
<head>
<title>Ogre::GpuProgramUsage Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1GpuProgramUsage.html">GpuProgramUsage</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::GpuProgramUsage Class Reference<div class="ingroups"><a class="el" href="group__Materials.html">Materials</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::GpuProgramUsage" --><!-- doxytag: inherits="Ogre::Resource::Listener,Ogre::AllocatedObject" -->
<p>This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.  
 <a href="classOgre_1_1GpuProgramUsage.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::GpuProgramUsage:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1GpuProgramUsage__inherit__graph.gif" border="0" usemap="#Ogre_1_1GpuProgramUsage_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1GpuProgramUsage_inherit__map" id="Ogre_1_1GpuProgramUsage_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1Resource_1_1Listener.html" title="Ogre::Resource::Listener" alt="" coords="5,5,173,35"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="197,5,277,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1GpuProgramUsage-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a75e48f93f8076f90ea0cfbe63052683d">GpuProgramUsage</a> (<a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> gptype, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *parent)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor.  <a href="#a75e48f93f8076f90ea0cfbe63052683d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#aad3a4915c2cddc6042ebe8f9c38f9700">GpuProgramUsage</a> (const <a class="el" href="classOgre_1_1GpuProgramUsage.html">GpuProgramUsage</a> &amp;rhs, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *newparent)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy constructor.  <a href="#aad3a4915c2cddc6042ebe8f9c38f9700"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a9a5ce7fed0a695aa6b8c54ab4dbe24d7">~GpuProgramUsage</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a9c322a46459f43021cb71d3ada369428">getType</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the type of program we're trying to link to.  <a href="#a9c322a46459f43021cb71d3ada369428"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a512e5a33561e116ad63042ec383bc911">setProgramName</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, bool resetParams=true)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the name of the program to use.  <a href="#a512e5a33561e116ad63042ec383bc911"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a6d21e305d7dd1524e859b1c916cc9780">setProgram</a> (<a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> &amp;prog)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the program to use.  <a href="#a6d21e305d7dd1524e859b1c916cc9780"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a8591c555a993fb63833caf6f013b0670">getProgram</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the program being used.  <a href="#a8591c555a993fb63833caf6f013b0670"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a093bd8181272357ef88b8c4a1f5f028e">getProgramName</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the program being used.  <a href="#a093bd8181272357ef88b8c4a1f5f028e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a91c1c956ce21910fb19b533d00761d41">setParameters</a> (<a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> params)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the program parameters that should be used; because parameters can be shared between multiple usages for efficiency, this method is here for you to register externally created parameter objects.  <a href="#a91c1c956ce21910fb19b533d00761d41"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a2a798e8d547336d730633b445144b476">getParameters</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the parameters being used here.  <a href="#a2a798e8d547336d730633b445144b476"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a998ff466eb484f98eea125257cc43db9">_load</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Load this usage (and ensure program is loaded)  <a href="#a998ff466eb484f98eea125257cc43db9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#ae8445ca73de5edc403bcb310f96a7f84">_unload</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Unload this usage.  <a href="#ae8445ca73de5edc403bcb310f96a7f84"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a22bb67a36e44cc6202dd87bc802a0736">unloadingComplete</a> (<a class="el" href="classOgre_1_1Resource.html">Resource</a> *prog)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called whenever the resource has been unloaded.  <a href="#a22bb67a36e44cc6202dd87bc802a0736"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#af7656f20d47cd7df24b98bc4b44bf8ef">loadingComplete</a> (<a class="el" href="classOgre_1_1Resource.html">Resource</a> *prog)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called whenever the resource finishes loading.  <a href="#af7656f20d47cd7df24b98bc4b44bf8ef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Resource_1_1Listener.html#a7e351c772904425efce5e94f0418e6ca">backgroundLoadingComplete</a> (<a class="el" href="classOgre_1_1Resource.html">Resource</a> *)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Callback to indicate that background loading has completed.  <a href="#a7e351c772904425efce5e94f0418e6ca"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Resource_1_1Listener.html#abcafaeb14fede970bb6a1f1920dcf2e0">backgroundPreparingComplete</a> (<a class="el" href="classOgre_1_1Resource.html">Resource</a> *)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Callback to indicate that background preparing has completed.  <a href="#abcafaeb14fede970bb6a1f1920dcf2e0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Resource_1_1Listener.html#a7951abdcff85efd6cf58a49d94442f67">preparingComplete</a> (<a class="el" href="classOgre_1_1Resource.html">Resource</a> *)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">called whenever the resource finishes preparing (paging into memory).  <a href="#a7951abdcff85efd6cf58a49d94442f67"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a66d948e45a9b9d9b2de2b07ce5497347">recreateParameters</a> ()</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#aa9470d8b504c842c012506954793cc6b">mType</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#af80f70922010924ae5ea3d8ceb7e5c35">mParent</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a9da44f0dcbbf0fb37bcb0b92321b4036">mProgram</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#acc40c8abeb4e5c906307283ccd96d260">mParameters</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">program parameters  <a href="#acc40c8abeb4e5c906307283ccd96d260"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a6b0ee311ec8d68e62631716177a2320d">mRecreateParams</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether to recreate parameters next load.  <a href="#a6b0ee311ec8d68e62631716177a2320d"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Using a vertex or fragment program can get fairly complex; besides the fairly rudimentary process of binding a program to the GPU for rendering, managing usage has few complications, such as: <ul>
<li>
Programs can be high level (e.g. Cg, RenderMonkey) or low level (assembler). Using either should be relatively seamless, although high-level programs give you the advantage of being able to use named parameters, instead of just indexed registers </li>
<li>
Programs and parameters can be shared between multiple usages, in order to save memory </li>
<li>
When you define a user of a program, such as a material, you often want to be able to set up the definition but not load / compile / assemble the program at that stage, because it is not needed just yet. The program should be loaded when it is first needed, or earlier if specifically requested. The program may not be defined at this time, you may want to have scripts that can set up the definitions independent of the order in which those scripts are loaded. </li>
</ul>
This class packages up those details so you don't have to worry about them. For example, this class lets you define a high-level program and set up the parameters for it, without having loaded the program (which you normally could not do). When the program is loaded and compiled, this class will then validate the parameters you supplied earlier and turn them into runtime parameters. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>Just incase it wasn't clear from the above, this class provides linkage to both <a class="el" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a> and <a class="el" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>, despite its name. </dd></dl>

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00073">73</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a75e48f93f8076f90ea0cfbe63052683d"></a><!-- doxytag: member="Ogre::GpuProgramUsage::GpuProgramUsage" ref="a75e48f93f8076f90ea0cfbe63052683d" args="(GpuProgramType gptype, Pass *parent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a75e48f93f8076f90ea0cfbe63052683d">Ogre::GpuProgramUsage::GpuProgramUsage</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>gptype</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>parent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Default constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">gptype</td><td>The type of program to link to </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aad3a4915c2cddc6042ebe8f9c38f9700"></a><!-- doxytag: member="Ogre::GpuProgramUsage::GpuProgramUsage" ref="aad3a4915c2cddc6042ebe8f9c38f9700" args="(const GpuProgramUsage &amp;rhs, Pass *newparent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a75e48f93f8076f90ea0cfbe63052683d">Ogre::GpuProgramUsage::GpuProgramUsage</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1GpuProgramUsage.html">GpuProgramUsage</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>newparent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Copy constructor. </p>

</div>
</div>
<a class="anchor" id="a9a5ce7fed0a695aa6b8c54ab4dbe24d7"></a><!-- doxytag: member="Ogre::GpuProgramUsage::~GpuProgramUsage" ref="a9a5ce7fed0a695aa6b8c54ab4dbe24d7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GpuProgramUsage.html#a9a5ce7fed0a695aa6b8c54ab4dbe24d7">Ogre::GpuProgramUsage::~GpuProgramUsage</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a998ff466eb484f98eea125257cc43db9"></a><!-- doxytag: member="Ogre::GpuProgramUsage::_load" ref="a998ff466eb484f98eea125257cc43db9" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GpuProgramUsage.html#a998ff466eb484f98eea125257cc43db9">Ogre::GpuProgramUsage::_load</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Load this usage (and ensure program is loaded) </p>

</div>
</div>
<a class="anchor" id="ae8445ca73de5edc403bcb310f96a7f84"></a><!-- doxytag: member="Ogre::GpuProgramUsage::_unload" ref="ae8445ca73de5edc403bcb310f96a7f84" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GpuProgramUsage.html#ae8445ca73de5edc403bcb310f96a7f84">Ogre::GpuProgramUsage::_unload</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Unload this usage. </p>

</div>
</div>
<a class="anchor" id="a7e351c772904425efce5e94f0418e6ca"></a><!-- doxytag: member="Ogre::GpuProgramUsage::backgroundLoadingComplete" ref="a7e351c772904425efce5e94f0418e6ca" args="(Resource *)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Resource_1_1Listener.html#a7e351c772904425efce5e94f0418e6ca">Ogre::Resource::Listener::backgroundLoadingComplete</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Resource.html">Resource</a> *&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Callback to indicate that background loading has completed. </p>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000007">Deprecated:</a></b></dt><dd>Use loadingComplete instead. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1Entity.html#a362ee625bacf70c5e6820fa761f43f02">Ogre::Entity</a>.</p>

<p>Definition at line <a class="el" href="OgreResource_8h_source.html#l00091">91</a> of file <a class="el" href="OgreResource_8h_source.html">OgreResource.h</a>.</p>

</div>
</div>
<a class="anchor" id="abcafaeb14fede970bb6a1f1920dcf2e0"></a><!-- doxytag: member="Ogre::GpuProgramUsage::backgroundPreparingComplete" ref="abcafaeb14fede970bb6a1f1920dcf2e0" args="(Resource *)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Resource_1_1Listener.html#abcafaeb14fede970bb6a1f1920dcf2e0">Ogre::Resource::Listener::backgroundPreparingComplete</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Resource.html">Resource</a> *&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Callback to indicate that background preparing has completed. </p>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000008">Deprecated:</a></b></dt><dd>Use preparingComplete instead. </dd></dl>

<p>Definition at line <a class="el" href="OgreResource_8h_source.html#l00097">97</a> of file <a class="el" href="OgreResource_8h_source.html">OgreResource.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2a798e8d547336d730633b445144b476"></a><!-- doxytag: member="Ogre::GpuProgramUsage::getParameters" ref="a2a798e8d547336d730633b445144b476" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> <a class="el" href="classOgre_1_1GpuProgramUsage.html#a2a798e8d547336d730633b445144b476">Ogre::GpuProgramUsage::getParameters</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the parameters being used here. </p>

</div>
</div>
<a class="anchor" id="a8591c555a993fb63833caf6f013b0670"></a><!-- doxytag: member="Ogre::GpuProgramUsage::getProgram" ref="a8591c555a993fb63833caf6f013b0670" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a>&amp; <a class="el" href="classOgre_1_1GpuProgramUsage.html#a8591c555a993fb63833caf6f013b0670">Ogre::GpuProgramUsage::getProgram</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the program being used. </p>

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00122">122</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>

</div>
</div>
<a class="anchor" id="a093bd8181272357ef88b8c4a1f5f028e"></a><!-- doxytag: member="Ogre::GpuProgramUsage::getProgramName" ref="a093bd8181272357ef88b8c4a1f5f028e" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1GpuProgramUsage.html#a093bd8181272357ef88b8c4a1f5f028e">Ogre::GpuProgramUsage::getProgramName</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the program being used. </p>

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00124">124</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9c322a46459f43021cb71d3ada369428"></a><!-- doxytag: member="Ogre::GpuProgramUsage::getType" ref="a9c322a46459f43021cb71d3ada369428" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> <a class="el" href="classOgre_1_1GpuProgramUsage.html#a9c322a46459f43021cb71d3ada369428">Ogre::GpuProgramUsage::getType</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the type of program we're trying to link to. </p>

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00101">101</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>

</div>
</div>
<a class="anchor" id="af7656f20d47cd7df24b98bc4b44bf8ef"></a><!-- doxytag: member="Ogre::GpuProgramUsage::loadingComplete" ref="af7656f20d47cd7df24b98bc4b44bf8ef" args="(Resource *prog)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GpuProgramUsage.html#af7656f20d47cd7df24b98bc4b44bf8ef">Ogre::GpuProgramUsage::loadingComplete</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Resource.html">Resource</a> *&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called whenever the resource finishes loading. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>If a <a class="el" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> has been marked as background loaded (</dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Resource.html#ae0a0007de944eb3c2f933a372a752b35" title="Tells the resource whether it is background loaded or not.">Resource::setBackgroundLoaded</a>), the call does not itself occur in the thread which is doing the loading; when loading is complete a response indicator is placed with the <a class="el" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various resource managers...">ResourceGroupManager</a>, which will then be sent back to the listener as part of the application's primary frame loop thread. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Resource_1_1Listener.html#ac8d962ac52ef53a2ad6ddbdc5b6c9655">Ogre::Resource::Listener</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::GpuProgramUsage::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7951abdcff85efd6cf58a49d94442f67"></a><!-- doxytag: member="Ogre::GpuProgramUsage::preparingComplete" ref="a7951abdcff85efd6cf58a49d94442f67" args="(Resource *)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Resource_1_1Listener.html#a7951abdcff85efd6cf58a49d94442f67">Ogre::Resource::Listener::preparingComplete</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Resource.html">Resource</a> *&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>called whenever the resource finishes preparing (paging into memory). </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>If a <a class="el" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> has been marked as background loaded (</dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Resource.html#ae0a0007de944eb3c2f933a372a752b35" title="Tells the resource whether it is background loaded or not.">Resource::setBackgroundLoaded</a>) the call does not itself occur in the thread which is doing the preparing; when preparing is complete a response indicator is placed with the <a class="el" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various resource managers...">ResourceGroupManager</a>, which will then be sent back to the listener as part of the application's primary frame loop thread. </dd></dl>

<p>Definition at line <a class="el" href="OgreResource_8h_source.html#l00118">118</a> of file <a class="el" href="OgreResource_8h_source.html">OgreResource.h</a>.</p>

</div>
</div>
<a class="anchor" id="a66d948e45a9b9d9b2de2b07ce5497347"></a><!-- doxytag: member="Ogre::GpuProgramUsage::recreateParameters" ref="a66d948e45a9b9d9b2de2b07ce5497347" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GpuProgramUsage.html#a66d948e45a9b9d9b2de2b07ce5497347">Ogre::GpuProgramUsage::recreateParameters</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a91c1c956ce21910fb19b533d00761d41"></a><!-- doxytag: member="Ogre::GpuProgramUsage::setParameters" ref="a91c1c956ce21910fb19b533d00761d41" args="(GpuProgramParametersSharedPtr params)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GpuProgramUsage.html#a91c1c956ce21910fb19b533d00761d41">Ogre::GpuProgramUsage::setParameters</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a>&#160;</td>
          <td class="paramname"><em>params</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the program parameters that should be used; because parameters can be shared between multiple usages for efficiency, this method is here for you to register externally created parameter objects. </p>
<p>Otherwise, the parameters will be created for you when a program is linked. </p>

</div>
</div>
<a class="anchor" id="a6d21e305d7dd1524e859b1c916cc9780"></a><!-- doxytag: member="Ogre::GpuProgramUsage::setProgram" ref="a6d21e305d7dd1524e859b1c916cc9780" args="(GpuProgramPtr &amp;prog)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GpuProgramUsage.html#a6d21e305d7dd1524e859b1c916cc9780">Ogre::GpuProgramUsage::setProgram</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>prog</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the program to use. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Note that this will create a fresh set of parameters from the new program being linked, so if you had previously set parameters you will have to set them again. </dd></dl>

</div>
</div>
<a class="anchor" id="a512e5a33561e116ad63042ec383bc911"></a><!-- doxytag: member="Ogre::GpuProgramUsage::setProgramName" ref="a512e5a33561e116ad63042ec383bc911" args="(const String &amp;name, bool resetParams=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GpuProgramUsage.html#a512e5a33561e116ad63042ec383bc911">Ogre::GpuProgramUsage::setProgramName</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>resetParams</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the name of the program to use. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the program to use </td></tr>
    <tr><td class="paramname">resetParams</td><td>If true, this will create a fresh set of parameters from the new program being linked, so if you had previously set parameters you will have to set them again. If you set this to false, you must be absolutely sure that the parameters match perfectly, and in the case of named parameters refers to the indexes underlying them, not just the names. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a22bb67a36e44cc6202dd87bc802a0736"></a><!-- doxytag: member="Ogre::GpuProgramUsage::unloadingComplete" ref="a22bb67a36e44cc6202dd87bc802a0736" args="(Resource *prog)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GpuProgramUsage.html#a22bb67a36e44cc6202dd87bc802a0736">Ogre::GpuProgramUsage::unloadingComplete</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Resource.html">Resource</a> *&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called whenever the resource has been unloaded. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1Resource_1_1Listener.html#a9f8cdeb73a65a6a1c018e5ac783dfafe">Ogre::Resource::Listener</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="acc40c8abeb4e5c906307283ccd96d260"></a><!-- doxytag: member="Ogre::GpuProgramUsage::mParameters" ref="acc40c8abeb4e5c906307283ccd96d260" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> <a class="el" href="classOgre_1_1GpuProgramUsage.html#acc40c8abeb4e5c906307283ccd96d260">Ogre::GpuProgramUsage::mParameters</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>program parameters </p>

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00082">82</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>

</div>
</div>
<a class="anchor" id="af80f70922010924ae5ea3d8ceb7e5c35"></a><!-- doxytag: member="Ogre::GpuProgramUsage::mParent" ref="af80f70922010924ae5ea3d8ceb7e5c35" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Pass.html">Pass</a>* <a class="el" href="classOgre_1_1GpuProgramUsage.html#af80f70922010924ae5ea3d8ceb7e5c35">Ogre::GpuProgramUsage::mParent</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00077">77</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9da44f0dcbbf0fb37bcb0b92321b4036"></a><!-- doxytag: member="Ogre::GpuProgramUsage::mProgram" ref="a9da44f0dcbbf0fb37bcb0b92321b4036" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> <a class="el" href="classOgre_1_1GpuProgramUsage.html#a9da44f0dcbbf0fb37bcb0b92321b4036">Ogre::GpuProgramUsage::mProgram</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00079">79</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>

</div>
</div>
<a class="anchor" id="a6b0ee311ec8d68e62631716177a2320d"></a><!-- doxytag: member="Ogre::GpuProgramUsage::mRecreateParams" ref="a6b0ee311ec8d68e62631716177a2320d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1GpuProgramUsage.html#a6b0ee311ec8d68e62631716177a2320d">Ogre::GpuProgramUsage::mRecreateParams</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Whether to recreate parameters next load. </p>

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00085">85</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa9470d8b504c842c012506954793cc6b"></a><!-- doxytag: member="Ogre::GpuProgramUsage::mType" ref="aa9470d8b504c842c012506954793cc6b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> <a class="el" href="classOgre_1_1GpuProgramUsage.html#aa9470d8b504c842c012506954793cc6b">Ogre::GpuProgramUsage::mType</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGpuProgramUsage_8h_source.html#l00076">76</a> of file <a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreGpuProgramUsage_8h_source.html">OgreGpuProgramUsage.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:56
</p>
</body>
</html>
